** ANYAPP.prg  Alan Schwartz, Micromega Systems, (c)  1991, 1992

** Here's a method to dynamically link multiple procedure libraries
** into your mainline at runtime.  
** It's a workaround for the 1 procedure limitation on SET PROCEDURE. 
** Dimension an array to hold the names of all the procedure files
** or apps we wish to open.  These will each have an identical "main" 
** execution segment that calls each named maintenance object in turn.
** The last name in the array should be the name of a procedure 
** ('RESTOF_APP' in this example) that continues the the application's 
** mainline processing.

** Kludge note: You will need a "dummy" program in the 'ANYAPP' project
** which contains a 'PROCEDURE procname' line for each procedure or function
** in that library.  This is needed only to resolve references during
** project rebuilds.  Mark this dummy program "Exclude", so it isn't
** built into the project !  The example is called AADUMMY.prg

SET TALK OFF
IF _WINDOWS
   MODIFY WINDOW SCREEN FONT "FOXFONT", 9
ENDIF
   
hide windows all

define window DemoTitle from 4, 1 to 6, 78 double color GR+/N
activate window DemoTitle
@ 0, 0 say "Illustrating multiple procedure apps open but separate maintenance objects."
define window Anywind from 7, 0 to 23, 25 double color bg+/br title " Any App's Window "
define window Lib_A  from 7, 26 to 23, 52 double color w+/bg title " Proc Lib A "
define window Lib_B  from 7, 53 to 23, 79 double color b/g title " Proc Lib B "
define window bl_arrow from 24, 0 to 24, 8 none color gr+*/r
activate window bl_arrow noshow
@ 0, 0 say "" 
activate window Anywind same
@ 0, 0 say ""
?  "Demonstration app:"
?  "Initialize call chain "

** Size the array for the number of procedure libraries to open
dimension procstak(4)  
store "PRCLIBA.APP" to procstak(1)
store "PRCLIBB.APP" to procstak(2)
store "RESTOF_APP" to procstak(3)  && This is the rest of the mainline below
store 1 to stakptr

** This is just display code: Its irrelevant to the linking technique.
?
? "Now chaining to "
? "libraries A & B "
move window bl_arrow to wlrow("Anywind") + 6, wlcol("Anywind") + 20

activate window bl_arrow top
wait  ""
** End of display code

** Here's the real point: This call starts the chain
do (procstak(stakptr)) with procstak, stakptr  && Open everything up
return

procedure Restof_App    && the "procedure files" have been chained !
parameters procstak, stakptr  

** unless there are more procedures to open later
** these parameters may now be ignored

** From here on down, we're just proving we can call out to
** any of the open procedures.

Activate window Anywind same
@ 6, 0 say ""
? "Now call a proc in Lib_A"
move window bl_arrow to wlrow("Anywind") + 9, wlcol("Anywind") + 18
activate window bl_arrow top
wait ""
do PRCLIBA2 with "Anyapp is Calling"

Activate window Anywind same
? "Call 2nd proc in Lib_A"
move window bl_arrow to wlrow("Anywind") + 10, wlcol("Anywind") + 18
activate window bl_arrow top
wait ""
do PRCLIBA3 with "Lib_A", "PROC"

activate window Anywind same
? "Now call as function "
move window bl_arrow to wlrow("Anywind") + 11, wlcol("Anywind") + 18
activate window bl_arrow top
wait ""
x = PRCLIBA3("Lib_A", "FUNC")

activate window Anywind same

? "Now call Lib_B"

zoom window bl_arrow norm at wlrow("Anywind") + 11, wlcol("Anywind") + 16 size 1, 40
activate window bl_arrow top
@ 0, 0 say repl("",39) + ""
do PRCLIBB2 with "Lib_B"
do PRCLIBB3 with "Lib_B", "PROC"
x = PRCLIBB3("Lib_B", "FUNC")

hide window bl_arrow
activate window Anywind 
do prcint1  && Internal procedure in Anywind
do anyapp2  && Standalong program call

zoom window bl_arrow norm at wlrow("Anywind") + 14, wlcol("Anywind") + 22 size 1, 12
activate window bl_arrow top
@ 0, 0 say REPL("", WCOLS("BL_ARROW") - 1) + ""
do prcliba1 with "Now trying a callback through PrcLibA1 to PRCINT1", "PrcInt1"

define window bl_arrow2 none at wlrow("Anywind") + 15, wlcol("Anywind") + 22 ;
    size 1, 12 color gr+*/r
activate window bl_arrow2 top
@ 0, 0 say "" + REPL("", WCOLS("BL_ARROW2") - 1)
wait window "Success! The libraries are maintainable as separate objects."
release windows bl_arrow, bl_arrow2, lib_A, lib_B, Anywind, DemoTitle
show windows all same

return


procedure prcint1
** A sample 'slave' procedure to ANYAPP
parameters msg
Activate window Anywind same

? "Internal proc " + PROG() 
? "in ANYAPP.prg "
return
